
--
-- Preparando o ambiente
--
TRUNCATE TABLE T_SIP_DEPENDENTE;
TRUNCATE TABLE T_SIP_FUNCIONARIO;
DELETE FROM T_SIP_DEPTO WHERE CD_DEPTO > 5;
COMMIT;

SELECT * FROM T_SIP_DEPTO;

--
-- Elimina e cria a sequencia com um valor significativo
--
DROP SEQUENCE SQ_SIP_DEPTO;

CREATE SEQUENCE SQ_SIP_DEPTO
START WITH 6
MAXVALUE 7;

SELECT * FROM T_SIP_DEPTO;

INSERT INTO T_SIP_DEPTO (CD_DEPTO, NM_DEPTO, SG_DEPTO, ST_DEPTO)
VALUES (SQ_SIP_DEPTO.NEXTVAL, 'Marketing Digital', 'MKD', 'A');

SELECT SQ_SIP_DEPTO.CURRVAL FROM DUAL;

INSERT INTO T_SIP_DEPTO (CD_DEPTO, NM_DEPTO, SG_DEPTO, ST_DEPTO)
VALUES (SQ_SIP_DEPTO.NEXTVAL, 'Esportes', 'ESP', 'A');

SELECT SQ_SIP_DEPTO.CURRVAL FROM DUAL;

--
-- Irá dar erro, pois o valo maximo da sequence já foi atingido.
--
INSERT INTO T_SIP_DEPTO (CD_DEPTO, NM_DEPTO, SG_DEPTO, ST_DEPTO)
VALUES (SQ_SIP_DEPTO.NEXTVAL, 'ESG', 'ESG', 'A');

/*
Error starting at line : 18 in command -
INSERT INTO T_SIP_DEPTO (CD_DEPTO, NM_DEPTO, SG_DEPTO, ST_DEPTO)
VALUES (SQ_SIP_DEPTO.NEXTVAL, 'ESG', 'ESG', 'A')
Error report -
ORA-08004: sequence SQ_SIP_DEPTO.NEXTVAL exceeds MAXVALUE and cannot be instantiated
*/

-- Ajustando o valor maximo da sequence
ALTER SEQUENCE SQ_SIP_DEPTO MAXVALUE 99;

SELECT TO_CHAR( TO_DATE('10/11/2003', 'DD/MM/YYYY'), 'DAY' ) FROM DUAL;

CREATE SEQUENCE SQ_SIP_FUNCIONARIO
START WITH 1;

INSERT INTO T_SIP_FUNCIONARIO(NR_MATRICULA, CD_DEPTO, NM_FUNCIONARIO,
DT_NASCIMENTO, DT_ADMISSAO, VL_SALARIO)
VALUES ( SQ_SIP_FUNCIONARIO.NEXTVAL, 6, 'Asi Sepol', 
SYSDATE - 10000, SYSDATE, DBMS_RANDOM.VALUE( 28000, 53000) );

SELECT * FROM T_SIP_FUNCIONARIO;


--
-- Multi INSERT
--
INSERT ALL



























